import numpy as np
import torch
import torch.nn as nn

from gradiator import gradiator

class Enable_Bwd(nn.Module):
	def to(self,device):
		nn.Module.to(self,device)
		self.device=device
		self.hidden["bwd_model"] = self.hidden["bwd_model"].to(device)
		return self
	def __init__(self,fwd,bwd_model):
		super().__init__()
		self.eval_hist=[]
		self.hidden["bwd_model"]=bwd_model
		def bwd(g,y,x):
			self.eval_hist.append([x,y,g])
			return self.hidden["bwd_model"](x,g)
		self.bwd_optim = torch.optim.Adam(self.hidden["bwd_model"].parameters(),lr=1e-2)
		self.gradiator = gradiator(fwd,bwd)
	def forward(self,x):
		return self.gradiator(x)
	def bwd_train(fwd,epsilon=1e-2,sample_dim=4,batch_size=10):
		for [x,y,go] in self.eval_hist: # you should take batch_size samples
			dx = epsilon*torch.randn(*x.shape,sample_dim)
			df = fwd(x+dx) - y # y=f(x)
			gx = self.bwd_model(x,y,go)
			to_sum = list(range(1,len(x.shape)))
			go = go.unsqueeze(len(go.shape)).expand(*go.shape,sample_dim)
			should = (gx*dx).sum(to_sum)
			found  = (go*df).sum(to_sum)
			loss = loss(should, found)
			self.bwd_optim.zero_grad()
			loss.requires_grad_().backward()
			self.bwd_optim.step()
